> ## Documentation Index
> Fetch the complete documentation index at: https://telnesstech-a0a16404.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Get product offering options for license

> Get all available product offerings a license can be changed to and
when the change can take effect.

When the license can be changed typically depends on the license terms,
billing cycle, and current product offering. As a rule of thumb (though not always),
upgrades and lateral moves are immediate, while downgrades take effect at the next
renewal date.




## OpenAPI

````yaml /api-reference/bundled_openapi.json get /licenses/{licenseId}/product-offering-options
openapi: 3.1.0
info:
  title: Telness Tech Connect
  version: 2.0.0-alpha
  description: >
    Telness Tech Connect API provides all you need to own your user's
    connectivity experience.


    Go back to [Telnesstech.com](https://telnesstech.com)
servers:
  - url: https://apiv2.example.com
    description: Connect API URL for your domain
security:
  - apiKey: []
  - bearerAuth: []
    apiKey: []
tags:
  - name: Auth
    description: Authenticate users and obtain access tokens.
  - name: Users
    description: Manage users.
  - name: Customers
    description: Manage customers.
  - name: Subscriptions
    description: Manage subscriptions and subscription.
  - name: Subscription Addons
    description: Manage subscription addons.
  - name: Subscription Usage
    description: Get subscription usage.
  - name: Subscribers
    description: Manage subscribers.
  - name: Licenses
    description: Manage licenses.
  - name: Product Offerings
    description: Browse product offerings.
  - name: Product Catalogs
    description: Browse product catalogs.
  - name: Product Discounts
    description: Discounts and promotions.
  - name: Orders
    description: Manage orders and line items.
  - name: Payment Intents
    description: >-
      Inspect payment intents, the money collected over card rails for orders
      and renewals.
  - name: Payment Links
    description: Create and manage payment links for orders and invoices.
  - name: Payment Sessions
    description: Create and manage payment sessions for orders.
  - name: Payment Profiles
    description: Manage customer payment profiles and methods.
  - name: Payment Profile Sessions
    description: Create sessions for setting up payment profiles.
  - name: Signing sessions
    description: Handle contract signing sessions for postpaid orders.
  - name: Porting
    description: Manage number porting for subscriptions.
  - name: Taxes
    description: Calculate taxes for products and line items.
  - name: Invoices
    description: Manage invoices and invoice items.
  - name: Tools
    description: >-
      Tools for address validation, number porting, device info, and network
      coverage.
  - name: Inventory
    description: Manage phone number inventory, SIM cards, and reservations.
  - name: Workflows
    description: Dynamic processing of customer journeys and events.
paths:
  /licenses/{licenseId}/product-offering-options:
    get:
      tags:
        - Licenses
      summary: Get product offering options for license
      description: >
        Get all available product offerings a license can be changed to and

        when the change can take effect.


        When the license can be changed typically depends on the license terms,

        billing cycle, and current product offering. As a rule of thumb (though
        not always),

        upgrades and lateral moves are immediate, while downgrades take effect
        at the next

        renewal date.
      operationId: getLicenseProductOfferingOptions
      parameters:
        - in: path
          name: licenseId
          required: true
          schema:
            type: string
          description: The unique identifier of the license.
      responses:
        '200':
          description: Available change options.
          content:
            application/json:
              schema:
                type: object
                required:
                  - items
                additionalProperties: false
                properties:
                  items:
                    type: array
                    items:
                      $ref: '#/components/schemas/ProductOfferingOption'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '403':
          $ref: '#/components/responses/Forbidden'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/InternalServerError'
components:
  schemas:
    ProductOfferingOption:
      type: object
      description: >-
        A product offering option available for subscription changes with
        scheduling information.
      required:
        - productOffering
        - changeSchedule
        - changeScheduleDate
      additionalProperties: false
      properties:
        productOffering:
          $ref: '#/components/schemas/EmbeddedProductOffering'
        changeSchedule:
          $ref: '#/components/schemas/ProductOfferingChangeSchedule'
        changeScheduleDate:
          type: string
          format: date
          x-ogen-type: telnesstech.com/apiv2/apiv2types.Date
          description: The date when the product offering change can take effect.
          example: '2024-02-01'
    EmbeddedProductOffering:
      type: object
      description: Embedded representation of a product offering.
      required:
        - productOfferingId
        - name
        - price
      properties:
        productOfferingId:
          type: string
          description: The unique identifier for the product offering.
        name:
          type: string
          description: The name of the product offering.
        price:
          $ref: '#/components/schemas/Price'
        group:
          $ref: '#/components/schemas/ProductOfferingGroup'
        imageUrl:
          type: string
          format: uri
          description: URL to the image representing the product offering.
          example: https://cdn.example.com/images/mobile-basic.png
    ProductOfferingChangeSchedule:
      type: string
      description: >
        The schedule type for when a product offering change can take effect.


        - INSTANT: Change takes effect immediately

        - FIRST_OF_NEXT_MONTH: Change takes effect on the first day of the next
        calendar month

        - NEXT_RENEWAL_DAY: Change takes effect on the next renewal date

        - NEXT_PAYMENT_DAY: Change takes effect at the end of the prepaid
        period, the next payment day
      enum:
        - INSTANT
        - FIRST_OF_NEXT_MONTH
        - NEXT_RENEWAL_DAY
        - NEXT_PAYMENT_DAY
    Error:
      type: object
      required:
        - message
        - code
      properties:
        message:
          type: string
          description: A human-readable message providing more details about the error.
        code:
          type: string
          description: A machine-readable code for the error.
        details:
          type: array
          description: Additional details about the error.
          items:
            type: object
            required:
              - message
              - code
            properties:
              message:
                type: string
                description: >-
                  A human-readable message providing more details about the
                  error.
              code:
                type: string
                description: A machine-readable code for the specific detail.
              property:
                type: string
                description: The property or field related to the error.
              suggestion:
                $ref: '#/components/schemas/Any'
                description: >
                  A suggested value for the particular property.


                  For example, this may be set when validating an address with
                  an alias, suggesting the expected value by the operator.
        hint:
          type: string
          description: A hint to help resolve the error.
    Price:
      type: object
      description: Pricing information with discount details.
      required:
        - cost
        - basePrice
        - currency
        - period
        - priceType
      properties:
        discount:
          type: number
          format: decimal
          description: The discount amount from the original price.
          example: 5
        netPrice:
          type: number
          format: decimal
          description: The final cost after all discounts are applied.
          example: 5
        currency:
          type: string
          description: The currency code.
          example: USD
        priceType:
          $ref: '#/components/schemas/PriceType'
        boundMonths:
          type: integer
          description: The number of months the price is bound to (for recurring prices).
          example: 12
        billingCycle:
          $ref: '#/components/schemas/BillingCycle'
        currencyOptions:
          type: object
          additionalProperties:
            type: number
            format: decimal
          description: >-
            Per-currency price overrides keyed by three-letter ISO currency code
            (e.g. "USD", "SEK"). Each value is the cost in that currency.
    ProductOfferingGroup:
      type: object
      description: A product group organizes related product offerings.
      required:
        - productOfferingGroupId
        - name
        - category
      additionalProperties: false
      properties:
        productOfferingGroupId:
          type: string
          description: Unique identifier for the product group.
          example: mobile-plans
        name:
          type: string
          description: Name of the product group in the requested locale.
          example: Mobile Plans
        description:
          type: string
          description: Description of the product group in the requested locale.
          example: >-
            Bundled cell subscriptions with unlimited calls and SMS with ILD
            enabled.
        category:
          $ref: '#/components/schemas/ProductCategory'
        internalDescription:
          type: string
          description: Internal description of the product group for operational use only.
          example: Core mobile offerings targeting consumer and business segments
    Any:
      oneOf:
        - type: string
        - type: number
        - type: boolean
        - type: object
          additionalProperties: true
        - type: array
    PriceType:
      type: string
      description: The type of pricing model applied to the product offering.
      enum:
        - ONE_TIME
        - RECURRING
    BillingCycle:
      type: object
      description: The billing cycle for recurring prices.
      required:
        - period
        - interval
      properties:
        period:
          type: string
          description: The billing period.
          enum:
            - MONTHLY
        interval:
          type: integer
          description: The interval of the billing period.
          example: 1
    ProductCategory:
      type: string
      description: >
        A product category is a sub-type for grouping offerings of the same
        type.


        Typically, product offerings of the same type with the same category
        allow

        for switching between them. For upgrading and downgrading subscriptions
        and

        licenses, we recommend using their corresponding endpoints though.


        Categories are grouped by their product type:


        **SUBSCRIPTION categories:**

        - `PRODUCT_CATEGORY_SUBSCRIPTION_CELL` - Mobile cellular subscription

        - `PRODUCT_CATEGORY_SUBSCRIPTION_DATA_SIM` - Data-only SIM subscription

        - `PRODUCT_CATEGORY_SUBSCRIPTION_BROADBAND` - Broadband internet
        subscription

        - `PRODUCT_CATEGORY_SUBSCRIPTION_M2M` - Machine-to-machine IoT
        subscription

        - `PRODUCT_CATEGORY_TRAVEL_ESIM` - Travel eSIM subscription for
        international roaming


        **SUBSCRIPTION_ADDON categories:**

        - `PRODUCT_CATEGORY_EXTRA_DATA` - Additional data package addon

        - `PRODUCT_CATEGORY_TRAVEL_ESIM_PACKAGE` - Travel eSIM data package with
        country/region coverage

        - `PRODUCT_CATEGORY_ABROAD` - International roaming addon


        **EXTERNAL_PRODUCT categories:**

        - `PRODUCT_CATEGORY_EXTERNAL_PRODUCT` - External purchasable product

        - `PRODUCT_CATEGORY_EXTERNAL_PRODUCT_ADDON` - Addon for external product
      enum:
        - PRODUCT_CATEGORY_SUBSCRIPTION_CELL
        - PRODUCT_CATEGORY_SUBSCRIPTION_DATA_SIM
        - PRODUCT_CATEGORY_SUBSCRIPTION_BROADBAND
        - PRODUCT_CATEGORY_SUBSCRIPTION_M2M
        - PRODUCT_CATEGORY_TRAVEL_ESIM
        - PRODUCT_CATEGORY_EXTRA_DATA
        - PRODUCT_CATEGORY_TRAVEL_ESIM_PACKAGE
        - PRODUCT_CATEGORY_ABROAD
        - PRODUCT_CATEGORY_EXTERNAL_PRODUCT
        - PRODUCT_CATEGORY_EXTERNAL_PRODUCT_ADDON
      example: PRODUCT_CATEGORY_SUBSCRIPTION_CELL
  responses:
    BadRequest:
      description: The request was malformed or invalid.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    Unauthorized:
      description: Authentication is required to access this resource.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    Forbidden:
      description: Access to this resource is forbidden.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    NotFound:
      description: The requested resource was not found.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    InternalServerError:
      description: An unexpected error occurred on the server.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
  securitySchemes:
    apiKey:
      type: apiKey
      in: header
      name: X-Api-Key
      description: >
        An API key that grants access to the Connect API. You can create and
        manage API keys in the portal.
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >
        Bearer authentication with JWT tokens is used to authenticate users.


        Do note that a valid API keys is also required to access the Connect API
        to prove that requests are made by a trusted party.


        Requests with a JWT token is scoped to the permissions of the user the
        token belongs to, regardless of the API key used.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.